import shared.model.structure.*;  // Particle
import shared.model.display.Display;    // Display
import shared.constants.*;
import shared.update.Evolver;
import shared.model.SimulationModel; // SimulationModel

import java.awt.event.*;
import java.awt.*;

import javax.swing.event.*;
import javax.swing.*;

import javax.vecmath.*;
import java.util.*;

import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import javax.media.j3d.*;
import javax.vecmath.*;


public class main extends JPanel
{
        static float simulationSize = 2000f * Units.ANGSTROMS_PER_METRE;
        static float displayScale = 10f/simulationSize;
        static Display display;
        static boolean isRunning = false;
        static float timeUnit = (float) Math.pow(10.0, -6.0);
        static float timeVal = 1f;
        static float timeStep = timeUnit * timeVal;
        static float elapsedTime = 0f;

        static Control control;
        static SimulationModel simulationModel;
        static Evolver evolver;

	public main()
	{}

	public static void main(String[] args) throws Exception
	{
                simulationModel = new SimulationModel();
                simulationModel.setSimulationSize(simulationSize);

                // create the updating object
                evolver = new Evolver(simulationModel);
                evolver.setTimestep(timeStep);

                // Create the control window
                control = new Control();

                while (true)
                {
                        if (isRunning)
                        {

                               evolver.update();
                               elapsedTime += timeStep;
                               control.setElapsedTime(elapsedTime);
                               Thread.currentThread().sleep(1);
                        }

                }
	}

        public static void setTimeUnit(float tu)
        {
                timeUnit = tu;
                timeStep = timeUnit * timeVal;
                evolver.setTimestep(timeStep);
        }

        public static void setTimeValue(float tv)
        {
                timeVal = tv;
                timeStep = timeUnit * timeVal;
                evolver.setTimestep(timeStep);
        }

        public static float getTimeUnit()
        {
                return timeUnit;
        }

        public static void setElapsedTime()
        {
                control.setElapsedTime(elapsedTime);
        }

        public static void setRunning(boolean run)
        {
                isRunning = run;
        }

        public static boolean getRunning()
        {
                return isRunning;
        }

        public static void loadTemplateFile(String filename)
        {
                simulationModel.loadFile(filename);
        }

        public static void loadSimulationFile(String filename)
        {
                simulationModel.loadFile(filename);
                simulationModel.display();
        }

        public static void newModel()
        {
                simulationModel = new SimulationModel();
                simulationModel.setSimulationSize(simulationSize);
        }
}




