import javax.swing.*;
import java.awt.event.*;

import java.io.*;

import shared.constants.*;

public class mainMenu extends JMenuBar
{
  	JMenu[] menu;

  public mainMenu(JFrame frm)
  {
        super();
        final JFrame frame = frm;

        JMenuItem menuItem;

        // Declare menus as heavyweight. This ensures that they are printed on top of
        // the Java3d Canvas
        JPopupMenu.setDefaultLightWeightPopupEnabled(false);

        // declare an array of menus
        menu = new JMenu[1];

        ///////////// File menu ////////////////////
        menu[0] = new JMenu("File");
        menu[0].setMnemonic('F');

	// New simulation
        menuItem = new JMenuItem("New");
        menuItem.setMnemonic('n');
        menuItem.addActionListener(
        new ActionListener()
        {
                public void actionPerformed(ActionEvent e)
                {
                        main.newModel();
                }
        }
        );
        menu[0].add(menuItem);

        // Create a template file loader
        final JFileChooser fcTemp = new JFileChooser(new File(Config.TEMPLATE_FILE_DIR));
        fcTemp.setMultiSelectionEnabled(false);
        menuItem = new JMenuItem("Load template file");
        menuItem.addActionListener(
        new ActionListener()
        {
                public void actionPerformed(ActionEvent e)
                {
                        int templateResult = fcTemp.showOpenDialog(frame);
                        File templateFile = fcTemp.getSelectedFile();
                        if (templateResult == JFileChooser.APPROVE_OPTION)
                        {
                                main.loadTemplateFile(templateFile.getPath());
                        }
                }
        }
        );
        menu[0].add(menuItem);

        // Create a template file loader
        final JFileChooser fcObj = new JFileChooser(new File(Config.OBJECT_FILE_DIR));
        fcObj.setMultiSelectionEnabled(false);
        menuItem = new JMenuItem("Load object file");
        menuItem.addActionListener(
        new ActionListener()
        {
                public void actionPerformed(ActionEvent e)
                {
                        int objectResult = fcObj.showOpenDialog(frame);
                        File objectFile = fcObj.getSelectedFile();
                        if (objectResult == JFileChooser.APPROVE_OPTION)
                        {
                                main.loadSimulationFile(objectFile.getPath());
                        }
                }
        }
        );
        menu[0].add(menuItem);

	// Exit
        menuItem = new JMenuItem("Exit");
        menuItem.setMnemonic('x');
        menuItem.addActionListener(
        new ActionListener()
        {
                public void actionPerformed(ActionEvent e)
                {
                        System.exit(0);
                }
        }
        );
        menu[0].add(menuItem);

        add(menu[0]);
  }
}

