package shared.model.structure;

import java.util.*;

public class InteractionTemplate
{
        private String id;
        private String type;
        private String[] componentPaths;

        private String[] potentialTemplates;
        private String[] forceMults;
        private String[] valueMults;

        // componentPaths are the paths to the component from the current level.
        // this uses the hashcode format. e.g.:
        // for the first particle in the second subObject of the current object it would be "O2:P1"

        public InteractionTemplate(String i)
        {
                id = i;
                componentPaths = new String[0];
                potentialTemplates = new String[0];
                forceMults = new String[0];
                valueMults = new String[0];
        }

        public void setPotentialTemplates(String[] pt)
        {
                potentialTemplates = pt;
        }

        public String[] getPotentialTemplates()
        {
                return potentialTemplates;
        }
        public void setForceMults(String[] fm)
        {
                forceMults = fm;
        }

        public String[] getForceMults()
        {
                return forceMults;
        }
        public void setValueMults(String[] vm)
        {
                valueMults = vm;
        }

        public String[] getValueMults()
        {
                return valueMults;
        }

        public void setComponentPaths(String[] ic)
        {
                componentPaths = ic;
        }

        public String[] getComponentPaths()
        {
                return componentPaths;
        }

        public void setId(String i)
        {
                id = i;
        }

        public String getId()
        {
                return id;
        }

        public String toString()
        {
                return id + " (InteractionTemplate)";
        }

        public void setType(String t)
        {
                type = t;
        }

        public String getType()
        {
                return type;
        }
}