package shared.model.structure;

import java.util.*;

import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.mouse.*;

import javax.media.j3d.*;
import javax.vecmath.*;

public class ParticleTemplate
{
        private String id;
        private float mass;
        private Shape shape;
        private Vector states;

        private Vector3f centreOfMass;
        private AxisAngle4f orientation;

        /*
        private String templateName;
        private float mass;
        private Shape shape;
        private Vector states;

        private Vector3f centreOfMass;
        private AxisAngle4f orientation;

        public ParticleTemplate()
        {
                templateName = "";
                mass = 0f;
                shape = new Shape();
                states = new Vector();

                centreOfMass = new Vector3f();
                orientation = new AxisAngle4f();
        }
        */

        public ParticleTemplate(String i)
        {
                id = i;
                mass = 0f;
                shape = new Shape();
                states = new Vector();

                centreOfMass = new Vector3f();
                orientation = new AxisAngle4f();
        }

        public String getId()
        {
                return id;
        }

        public void setId(String i)
        {
                id = i;
        }

        public String toString()
        {
                return id + " (ParticleTemplate)";
        }

        public void setMass(float m)
        {
                mass = m;
        }

        public float getMass()
        {
                return mass;
        }

        public void setShape(String n, float[] dim)
        {
                shape.setName(n);
                shape.setDimensions(dim);
        }

        public void setStateName(int state, String s)
        {
                ((ParticleState)(states.elementAt(state))).setName(s);
        }

        public void setStateColour(int state, Color3f col)
        {
                ((ParticleState)(states.elementAt(state))).setColour(col);
        }

        public void setStateAlpha(int state, float a)
        {
                ((ParticleState)(states.elementAt(state))).setAlpha(a);
        }

        public void addState(String n, Color3f col, float a)
        {
                ParticleState newState = new ParticleState();
                newState.setName(n);
                newState.setColour(col);
                newState.setAlpha(a);
                states.addElement(newState);
        }

        public void setCentreOfMass(Vector3f com)
        {
                centreOfMass = com;
        }

        public void setOrientation(AxisAngle4f orient)
        {
                orientation = orient;
        }

        public String getShapeName()
        {
                return shape.getName();
        }

        public float[] getShapeDimensions()
        {
                return shape.getDimensions();
        }

        public float getShapeRadius()
        {
                return shape.getRadius();
        }

        public String getStateName(int state)
        {
                return ((ParticleState)(states.elementAt(state))).getName();
        }

        public Color3f getStateColour(int state)
        {
                return ((ParticleState)(states.elementAt(state))).getColour();
        }

        public float getStateAlpha(int state)
        {
                return ((ParticleState)(states.elementAt(state))).getAlpha();
        }

        public int numStates()
        {
                return states.size();
        }

        public Vector3f getCentreOfMass()
        {
                return centreOfMass;
        }

        public AxisAngle4f getOrientation()
        {
                return orientation;
        }

        /*
        ////// Set details //////
        public void setName(String n)
        {
                templateName = n;
        }

        public void setMass(float m)
        {
                mass = m;
        }

        public void setShape(String n, float[] dim)
        {
                shape.setName(n);
                shape.setDimensions(dim);
        }

        public void setStateName(int state, String s)
        {
                ((ParticleState)(states.elementAt(state))).setName(s);
        }

        public void setStateColour(int state, Color3f col)
        {
                ((ParticleState)(states.elementAt(state))).setColour(col);
        }

        public void setStateAlpha(int state, float a)
        {
                ((ParticleState)(states.elementAt(state))).setAlpha(a);
        }

        public void addState(String n, Color3f col, float a)
        {
                ParticleState newState = new ParticleState();
                newState.setName(n);
                newState.setColour(col);
                newState.setAlpha(a);
                states.addElement(newState);
        }

        public void setCentreOfMass(Vector3f com)
        {
                centreOfMass = com;
        }

        public void setOrientation(AxisAngle4f orient)
        {
                orientation = orient;
        }

        ////// Get details //////
        public String getName()
        {
                return templateName;
        }

        public String getID()
        {
                return templateName;
        }

        public float getMass()
        {
                return mass;
        }

        public String getShapeName()
        {
                return shape.getName();
        }

        public float[] getShapeDimensions()
        {
                return shape.getDimensions();
        }

        public float getShapeRadius()
        {
                return shape.getRadius();
        }

        public String getStateName(int state)
        {
                return ((ParticleState)(states.elementAt(state))).getName();
        }

        public Color3f getStateColour(int state)
        {
                return ((ParticleState)(states.elementAt(state))).getColour();
        }

        public float getStateAlpha(int state)
        {
                return ((ParticleState)(states.elementAt(state))).getAlpha();
        }

        public int numStates()
        {
                return states.size();
        }

        public Vector3f getCentreOfMass()
        {
                return centreOfMass;
        }

        public AxisAngle4f getOrientation()
        {
                return orientation;
        }
        */

        /*
        public ParticleTemplate(String n)
        {
                ptname = n;
                size.add(new Float(1f));
                addState("Default", new Color3f(1f, 0.2f, 0.2f), 1f);
        }

        public Particle createInstance(int particleNum, Vector3f com)
        {
                Particle p = new Particle(particleNum+"-"+ptname, this);
                p.setCentreOfMass(com);

                return p;
        }

        public void setName(String n)
        {
                ptname = n;
        }

        public String getName()
        {
                return ptname;
        }

        public void addState(String name, Color3f col, float alpha)
        {
                stateName.add(name);
                stateColourR.add(new Float(col.x));
                stateColourG.add(new Float(col.y));
                stateColourB.add(new Float(col.z));
                stateAlpha.add(new Float(alpha));
        }

        public Color3f getColour(int state)
        {
                Object[] red = (Object[]) (stateColourR.toArray());
                Object[] green = (Object[]) (stateColourG.toArray());
                Object[] blue = (Object[]) (stateColourB.toArray());

                return new Color3f(((Float) red[state]).floatValue(),
                                   ((Float) green[state]).floatValue(),
                                   ((Float) blue[state]).floatValue());
        }

        public void setColour(int state, Color3f colour)
        {
                Object[] red = (Object[]) (stateColourR.toArray());
                Object[] green = (Object[]) (stateColourG.toArray());
                Object[] blue = (Object[]) (stateColourB.toArray());

                red[state] = new Float(colour.x);
                green[state] = new Float(colour.y);
                blue[state] = new Float(colour.z);

                stateColourR = new neuroml.core.List();
                stateColourG = new neuroml.core.List();
                stateColourB = new neuroml.core.List();

                for (int i=0; i<red.length; i++)
                {
                        stateColourR.add(red[i]);
                        stateColourG.add(green[i]);
                        stateColourB.add(blue[i]);
                }

        }

        public float getAlpha(int state)
        {
                Object[] alpha = (Object[]) (stateAlpha.toArray());
                return ((Float) alpha[state]).floatValue(); 
        }

        public String getShape()
        {
                return shape;
        }

        public void setShape(String s)
        {
                shape = s;
        }

        public float[] getSize()
        {
                Object[] sizeObjArray = (Object[]) (size.toArray());
                float[] sizeArray = new float[sizeObjArray.length];

                for (int i=0; i<sizeArray.length; i++)
                {
                        sizeArray[i] = ((Float) sizeObjArray[i]).floatValue();
                }

                return sizeArray;
        }

        public void setSize(float[] s)
        {
                size = new neuroml.core.List();
                for (int i=0; i<s.length; i++)
                {
                        size.add(new Float(s[i]));
                }
        }
        */
}

class Shape
{
        String name;
        float[] dimensions;

        Shape()
        {
                name = "";
                dimensions = new float[0];
        }

        ////// Set details //////
        void setName(String n)
        {
                name = n;
        }

        void setDimensions(float[] dim)
        {
                dimensions = dim;
        }

        ////// Get details //////
        String getName()
        {
                return name;
        }

        float[] getDimensions()
        {
                return dimensions;
        }

        float getRadius()
        {
                // Set the radius to be half the average of each dimension
                float rad = 0f;
                for (int i=0; i<dimensions.length; i++)
                {
                        rad += dimensions[i];
                }
                rad *= 0.5;

                return rad;
        }

}

class ParticleState
{
        String name;
        Color3f colour;
        float alpha;

        ParticleState()
        {
                name = "";
                colour = new Color3f(1f, 1f, 1f);
                alpha = 1f;
        }

        ////// Set details //////
        void setName(String n)
        {
                name = n;
        }

        void setColour(Color3f col)
        {
                colour = col;
        }

        void setAlpha(float a)
        {
                alpha = a;
        }

        ////// Get details //////
        String getName()
        {
                return name;
        }

        Color3f getColour()
        {
                return colour;
        }

        float getAlpha()
        {
                return alpha;
        }
}