package shared.model.structure;

import java.util.*;

public class Potential
{
        private String id;
        private String[] forces;
        private String[] values;

        public Potential(String i)
        {
                id = i;
                values = new String[0];
                forces = new String[0];
        }

        public void setId(String i)
        {
                id = i;
        }

        public String getId()
        {
                return id;
        }

        public void setForces(String[] f)
        {
                forces = f;
        }

        public String[] getForces()
        {
                return forces;
        }

        public void setValues(String[] v)
        {
                values = v;
        }

        public String[] getValues()
        {
                return values;
        }

        public String toString()
        {
                String s = id + " (Potential) ";
                for (int i=0; i<values.length; i++)
                {
                        s += values[i] + "," + forces[i] + "  ";
                }
                return s;
        }

        public float getForceAt(float x)
        {
                float f = 0f;

                for (int i=0; i<values.length-2; i++)
                {
                        float v1=0f;
                        float v2=0f;
                        float f1=0f;
                        float f2=0f;

                        try
                        {
                                v1 = Float.parseFloat(values[i]);
                                v2 = Float.parseFloat(values[i+1]);
                        }
                        catch (NumberFormatException e)
                        {
                        }

                        if (x>v1 && x<v2)
                        {
                                try
                                {
                                        f1 = Float.parseFloat(forces[i]);
                                        f2 = Float.parseFloat(forces[i+1]);
                                }
                                catch (NumberFormatException e)
                                {
                                }

                                f = (f2 - f1) * (x - v1) / (v2 - v1) + f1;
                        }
                }
                return f;
        }


        /*
        String name;
        InteractionTemplate template;

        // A list of the particle instances involved in the interaction
        Vector particles;

        public Interaction()
        {
                name = "";
                template = null;
                particles = new Vector();
        }

        public void setName(String n)
        {
                name = n;
        }

        public String getName()
        {
                return name;
        }

        public void setTemplate(InteractionTemplate t)
        {
                template = t;
        }

        public InteractionTemplate getTemplate()
        {
                return template;
        }

        public void setParticles(Vector p)
        {
                particles = p;
        }

        public Vector getParticles()
        {
                return particles;
        }

        public void addParticle(Object o)
        {
                particles.addElement(o);
        }
        */
}

