// -- a single bonding rule

package shared.model.structure;

import java.util.*;

public class Rule
{
        String id;
        String action;
        String templateId;
        String[] conditions;
        float probability;

        private Random rand;

        public Rule(String i)
        {
                id = i;
                action = "none";
                templateId = "";
                conditions = new String[0];
                probability = 0f;
                rand = new Random();
        }

        public void setRule(String act, String tmpl, String[] cons, float prob)
        {
                if (!(act.equals("add") || act.equals("drop") || act.equals("block")))
                {
                        action = "none";
                }
                else
                {
                        action = act;
                }

                templateId = tmpl;
                conditions = cons;
                probability = prob;
        }

        // -- test the rule with a given action and particle - return true if successful, else false
        // -- note that a returned false does not indicate that the action shouldn't be taken, other rules might return true.
        public boolean test(String testAction, String particleId)
        {
                // -- fail if wrong action
                if (!(action.equals(testAction)))
                {
                        return false;
                }

                // -- fail if the probability is not met
                if (rand.nextFloat() > probability) { return false; }

                // -- test each of the conditions in turn (fail if any not met - ie. logical AND)
                for (int i=0; i<conditions.length; i++)
                {
                        if (!(testCondition(conditions[i]))) { return false; }
                }

                return true;
        }

        public boolean testCondition(String condition)
        {
                return true;
        }

}