package shared.model.structure;

import neuroml.core.*;

import java.util.*;
import javax.vecmath.*;

public class SimObjectTemplate
{
        //String templateName;

        private String id;

        private String[] particleTemplateIds;
        private Vector3f[] particleCentreOfMass;
        private AxisAngle4f[] particleOrientation;

        private String[] subObjectTemplateIds;
        private Vector3f[] subObjectCentreOfMass;
        private AxisAngle4f[] subObjectOrientation;

        private String[] stateTemplateIds;

        public SimObjectTemplate(String i)
        {
                id = i;
                particleTemplateIds = new String[0];
                subObjectTemplateIds = new String[0];
                stateTemplateIds = new String[0];
        }

        public String getId()
        {
                return id;
        }

        public void setId(String i)
        {
                id = i;
        }

        public String[] getSubObjectTemplateIds()
        {
                return subObjectTemplateIds;
        }

        public Vector3f[] getSubObjectCentreOfMasses()
        {
                return subObjectCentreOfMass;
        }

        public AxisAngle4f[] getSubObjectOrientations()
        {
                return subObjectOrientation;
        }

        public void setSubObjects(String[] ids, Vector3f[] com, AxisAngle4f[] orient)
        {
                subObjectTemplateIds = ids;
                subObjectCentreOfMass = com;
                subObjectOrientation = orient;
        }

        public String[] getParticleTemplateIds()
        {
                return particleTemplateIds;
        }

        public Vector3f[] getParticleCentreOfMasses()
        {
                return particleCentreOfMass;
        }

        public AxisAngle4f[] getParticleOrientations()
        {
                return particleOrientation;
        }

        public void setParticles(String[] ids, Vector3f[] com, AxisAngle4f[] orient)
        {
                particleTemplateIds = ids;
                particleCentreOfMass = com;
                particleOrientation = orient;
        }

        //public void setParticleTemplateIds(String[] s)
        //{
        //        particleTemplateIds = s;
        //}


        //public void setSubObjectTemplateIds(String[] s)
        //{
        //        subObjectTemplateIds = s;
        //}

        public String[] getStateTemplateIds()
        {
                return stateTemplateIds;
        }

        public void setStateTemplateIds(String[] s)
        {
                stateTemplateIds = s;
        }

        public String toString()
        {
                return id + " (SimObjectTemplate)";
        }

        ////////// Get details /////////////

        //public Vector getObjectStates()
        //{
        //        return objectStates;
        //}

        //public String getName()
        //{
        //        return templateName;
        //}

        /*
        public Vector getParticleTemplateRefs()
        {
                return particleTemplateRefs;
        }

        public Object getParticleTemplateReference(int index)
        {
                Reference ref = (Reference) (particleTemplateRefs.elementAt(index));
                return (ParticleTemplate) (ref.getTemplate());
        }

        public int getNumParticleTemplates()
        {
                return particleTemplateRefs.size();
        }

        public Vector3f getParticleTemplateCentreOfMass(int index)
        {
                Reference ref = (Reference) (particleTemplateRefs.elementAt(index));
                return ref.getCentreOfMass();
        }

        public AxisAngle4f getParticleTemplateOrientation(int index)
        {
                Reference ref = (Reference) (particleTemplateRefs.elementAt(index));
                return ref.getOrientation();
        }

        public Object getObjectTemplateReference(int index)
        {
                Reference ref = (Reference) (simObjectTemplateRefs.elementAt(index));
                return (SimObjectTemplate) (ref.getTemplate());
        }

        public int getNumObjectTemplates()
        {
                return simObjectTemplateRefs.size();
        }

        public Vector3f getObjectTemplateCentreOfMass(int index)
        {
                Reference ref = (Reference) (simObjectTemplateRefs.elementAt(index));
                return ref.getCentreOfMass();
        }

        public AxisAngle4f getObjectTemplateOrientation(int index)
        {
                Reference ref = (Reference) (simObjectTemplateRefs.elementAt(index));
                return ref.getOrientation();
        }

        ////// Set details //////

        public void addInteraction(int stateNum, Interaction interact)
        {
                // create the state if it doesn't exist
                if (stateNum >= objectStates.size())
                {
                        objectStates.insertElementAt(new Vector(), stateNum);
                }

                ((Vector)(objectStates.elementAt(stateNum))).addElement(interact);
        }

        public void setObjectStates(Vector s)
        {
                objectStates = s;
        }

        public void setName(String n)
        {
                templateName = n;
        }

        public void addParticleTemplateReference(String hash, Vector3f com, AxisAngle4f orient)
        {
                Reference ref = new Reference();
                ref.setTemplate(p);
                ref.setCentreOfMass(com);
                ref.setOrientation(orient);

                particleTemplateRefs.addElement(ref);
        }

        public void addObjectTemplateReference(String hash, Vector3f com, AxisAngle4f orient)
        {
                Reference ref = new Reference();
                ref.setHash(hash);
                ref.setCentreOfMass(com);
                ref.setOrientation(orient);

                simObjectTemplateRefs.addElement(ref);
        }
*/
}
 /*
class Reference
{
        private String hash;
        private Vector3f centreOfMass;
        private AxisAngle4f orientation;

        Reference()
        {
                hash = "";
                centreOfMass = new Vector3f();
                orientation = new AxisAngle4f();
        }


        ////// Set details //////
        void setHash(String h)
        {
                hash = h;
        }

        void setCentreOfMass(Vector3f com)
        {
                centreOfMass = com;
        }

        void setOrientation(AxisAngle4f orient)
        {
                orientation = orient;
        }

        ////// Get details //////
        Object getHash()
        {
                return hash;
        }

        Vector3f getCentreOfMass()
        {
                return centreOfMass;
        }

        AxisAngle4f getOrientation()
        {
                return orientation;
        }
}
*/